<?php
/*
 ex: set tabstop=4 shiftwidth=4 autoindent:
 +-------------------------------------------------------------------------+
 | Copyright (C) 2009 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/

function banner_draw_navigation_text ($nav) {
   /* insert all your PHP functions that are accessible */
   $nav["banner.php:"] = array("title" => "banner title", "mapping" => "index.php:"
                              , "url" => "banner.php", "level" => "1");
//   $nav["banner.php:save"] = array("title" => "banner title", "mapping" => "index.php:"
//                                    , "url" => "banner.php", "level" => "1");
   return $nav;
}

function banner_config_arrays () {
   global $menu, $messages, $plgexample_menu;

   $menu['Utilities']['plugins/banner/banner.php'] = 'change banner';
}

function banner_scan_dir () {
        global $config;

        $ext = array('.jpg', '.png','.gif','bmp');
        $d = dir($config['base_path'] . '/plugins/banner/images/');
        $files = array('None' => 'None');
        while (false !== ($entry = $d->read())) {
                if ($entry != '.' && $entry != '..' && in_array(strtolower(substr($entry,-4)),$ext))
                        $files[$entry] = $entry;

        }
        $d->close();
        return $files;
}

function banner_config_settings () {
        global $tabs, $settings, $page_refresh_interval, $graph_timespans;

        if (isset($_SERVER['PHP_SELF']) && basename($_SERVER['PHP_SELF']) != 'settings.php')
                return;

        /* IF you want your own tab settings you have to create a new $tab and change "misc" */
        $tabs["misc"] = "Misc";
        // change the line above and uncomment the two following when you want your tabs
        // $tabs["banner"] = "banner";
        // $treeList = array_rekey(get_graph_tree_array(null, true), 'id', 'name');

        $defaultallow="on";
        $defaultallowguest="on";
        $banner_colorbg = array();
        $banner_colorbg[blue] = "blue";
        $banner_colorbg[red] = "red";
        $banner_colorbg[orange] = "orange";
        $banner_colorbg[black] = "black";
        $banner_colorbg[gray] = "gray";
        $banner_colorbg[maroon] = "maroon";
        $banner_colorbg[green] = "green";
        $banner_colorbg[olive] = "olive";
        $banner_colorbg[navy] = "navy";
        $banner_colorbg[purple] = "purple";
        $banner_colorbg[teal] = "teal";
        $banner_colorbg[silver] = "silver";
        $banner_colorbg[lime] = "lime";
        $banner_colorbg[yellow] = "yellow";
        $banner_colorbg[fuchsia] = "fuchsia";
        $banner_colorbg[aqua] = "aqua";
        $banner_colorbg[white] = "white";
        $temp = array(
                "banner_header" => array(
                        "friendly_name" => "banner settings",
                        "method" => "spacer",
                        ),
                "banneractivation" => array(
                        "friendly_name" => "Show the banner instant messaging",
                        "description" => "the banner instant messaging appear at the top of cacti. If messsage text is empty the banner will be not display too.",
                        'default' => $defaultallow,
                        "method" => "checkbox",
                        ),
                "banner_date" => array(
                        "friendly_name" => "banner date",
                        "description" => "The date when the banner will be display. format YYYY-MM-DD hh:mm:ss. If empty immediately when text or image.",
                        "default" => "",
                        "method" => "textbox",
                        "max_length" => 19,
                        ),
                "banner_txt" => array(
                        "friendly_name" => "banner text",
                        "description" => "The banner text to display.",
                        "default" => "",
                        "method" => "textbox",
                        "max_length" => 254,
                        ),
                "banner_fontsize" => array(
                        "friendly_name" => "banner fontsize",
                        "description" => "The font size text used. between 5 and 20.",
                        "default" => "10",
                        "method" => "textbox",
                        "max_length" => 10,
                        ),
                "banner_color" => array(
                        "friendly_name" => "banner text color",
                        "description" => "The banner text color . blue,red,orange,black,gray,maroon,green,olive,navy,purple,teal,silver,lime,yellow,fuchsia,aqua,white",
                        "default" => "black",
                        'method' => 'drop_array',
                        'array' => $banner_colorbg,
                        ),
                "banner_colorbg" => array(
                        "friendly_name" => "banner color background",
                        "description" => "The banner color background. blue,red,orange,black,gray,maroon,green,olive,navy,purple,teal,silver,lime,yellow,fuchsia,aqua,white. with option light ",
                        "default" => "red",
                        'method' => 'drop_array',
                        'array' => $banner_colorbg,
                        ),
                "banner_blink" => array(
                        "friendly_name" => "banner blinking",
                        "description" => "The banner is blinking (only Firefox and opera).",
                        "method" => "checkbox",
                        "default" => "off",
                        ),
                "banner_image" => array(
                        'friendly_name' => 'banner image',
                        'description' => 'The banner image under folder ./plugins/banner/images/ .',
                        'method' => 'drop_array',
                        'array' => banner_scan_dir(),
                        'default' => '',
                        ),
                "banner_scroll" => array(
                        "friendly_name" => "banner scrolling",
                        "description" => "The banner is scrolling.",
                        "method" => "checkbox",
                        "default" => "off",
                        ),
                "banner_width" => array(
                        "friendly_name" => "banner width",
                        "description" => "The length of the banner in pixel",
                        "default" => "1100",
                        "method" => "textbox",
                        "max_length" => 5,
                        ),
                "banner_allowed_guest_account" => array(
                        "friendly_name" => "allow guest account",
                        "description" => "if checked this plugin is allowed to the 'guest' account",
                        "method" => "checkbox",
                        'default' => $defaultallowguest,
                        ),
        );
        if (isset($settings["misc"]))
                $settings["misc"] = array_merge($settings["misc"], $temp);
        else
                $settings["misc"]=$temp;
        // change the 4 lines above and uncomment the 4 lines following when you want your tabs
        //if (isset($settings["banner"])) {
        //      $settings["banner"] = array_merge($settings["banner"], $temp);
        //}else {
        //      $settings["banner"]=$temp;
        //}
}

