<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2004-2009 The Cacti Group                                 |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************

    Author ......... Jean-Michel Pepin
    Contact ........ www.cacti.net
    Home Site ...... http://www.cacti.net
    Program ........ banner "plugin banner"
    Version ........ 0.1
    Purpose ........ let appear a banner at the top of each plugins. Could be use to 
                     inform cacti user for maintenance, problem or some puplicity.
                     Need PA 2.x (plugin architecture 2.x)
*******************************************************************************/
define("bannerVERSIONPLUGIN", "0.31");

function plugin_init_banner() {
	global $plugin_hooks;

}

/* plugin install - provides a generic PIA 2.x installer routine to register all plugin hook functions.
*/
function plugin_banner_install() {
   api_plugin_register_hook('banner', 'top_header_tabs',       'banner_show_tab',             "setup.php");
   api_plugin_register_hook('banner', 'top_graph_header_tabs', 'banner_show_tab',             "setup.php");
   api_plugin_register_hook('banner', 'config_arrays',         'banner_config_arrays',        "includes/settings.php");
   api_plugin_register_hook('banner', 'draw_navigation_text',  'banner_draw_navigation_text', "includes/settings.php");
   api_plugin_register_hook('banner', 'config_form',           'banner_config_form',          "setup.php");
   api_plugin_register_hook('banner', 'config_settings',       'banner_config_settings',      "includes/settings.php");
   api_plugin_register_hook('banner', 'api_graph_save',        'banner_api_graph_save',       "setup.php");
   api_plugin_register_hook('banner', 'body_style', 'banner_api_plugin_hook_function_body_style', "setup.php");
   /* uncomment if you need more hooks */
//   api_plugin_register_hook('banner', 'top_graph_refresh',     'banner_top_graph_refresh',    "setup.php");
//   api_plugin_register_hook('banner', 'device_action_array',   'banner_device_action_array',  "setup.php");
//   api_plugin_register_hook('banner', 'device_action_execute', 'banner_device_action_execute',"setup.php");
//   api_plugin_register_hook('banner', 'device_action_prepare', 'banner_device_action_prepare',"setup.php");
//   api_plugin_register_hook('banner', 'poller_output',         'banner_poller_output', 'poller_banner.php');
//   api_plugin_register_hook('banner', 'poller_bottom',         'banner_poller_bottom', 'poller_banner.php');

   // register the realm for each php file
   api_plugin_register_realm('banner', 'banner.php', 'View banner', 1);

   banner_setup_table_new ();
}

/* plugin uninstall - a generic uninstall routine.  Right now it will do nothing as I
   If you don't want the tables removed from the system except let it empty. */
function plugin_banner_uninstall () {
	/* Do any extra Uninstall stuff here */
}

function plugin_banner_upgrade () {
	/* Here we will upgrade to the newest version */
	banner_check_upgrade();
	return false;
}

function plugin_banner_check_config () {
        /* Here we will check to ensure everything is configured */
        banner_check_upgrade();
        return true;
}

function plugin_banner_version () {
	return banner_version();
}

function banner_check_upgrade () {
	global $config;

	$files = array('index.php', 'plugins.php', 'banner.php');
	if (isset($_SERVER['PHP_SELF']) && !in_array(basename($_SERVER['PHP_SELF']), $files)) {
		return;
	}

	$current = plugin_banner_version();
	$current = $current['version'];
	$old     = db_fetch_row("SELECT * FROM plugin_config WHERE directory='banner'");
	if (sizeof($old) && $current != $old["version"]) {
		/* if the plugin is installed and/or active */
		if ($old["status"] == 1 || $old["status"] == 4) {
			/* re-register the hooks */
			plugin_banner_install();

			/* perform a database upgrade */
			banner_database_upgrade();
		}

		/* update the plugin information */
		$info = plugin_banner_version();
		$id   = db_fetch_cell("SELECT id FROM plugin_config WHERE directory='banner'");
		db_execute("UPDATE plugin_config
			SET name='" . $info["longname"] . "',
			author='"   . $info["author"]   . "',
			webpage='"  . $info["homepage"] . "',
			version='"  . $info["version"]  . "'
			WHERE id='$id'");
	}
}

function banner_database_upgrade () {
}

function banner_check_dependencies() {
	global $plugins, $config;

	return true;
}

function banner_setup_table_new () {
}

function banner_version () {
    return array( 'name'     => 'banner',
            'version'     => bannerVERSIONPLUGIN,
            'longname'    => 'banner at the top of cacti plugins.',
            'author'    => 'Jean-Michel Pepin',
            'homepage'    => 'http://www.cacti.net',
            'email'    => '',
            'url'        => ''
            );
}

function banner_device_action_execute ($action) {
        global $config;

        if ($action != 'banner_your_action')
                return;
        /* Look at monitor as example */
        return;
}

function banner_device_action_prepare($save) {
        global $colors, $host_list;
        /* Look at monitor as example */
}

function banner_device_action_array($device_action_array) {
        /* here you can add actions in the devices view */
        /* Look at monitor as example */
#        $device_action_array['banner_your_action'] = 'banner action';
        return $device_action_array;
}

function banner_top_graph_refresh ($refresh) {
        /* change the refresh time of your view. Here as example banner.php */
        /* banner_refresh is supposed to be one parameter of the setting */
        if (basename($_SERVER['PHP_SELF']) != 'banner.php')
                return $refresh;
#        $r = read_config_option('banner_refresh');
#        if ($r == '' or $r < 1)
#                return $refresh;
#        return $r;
}

function banner_show_tab () {
  global $config, $user_auth_realms, $user_auth_realm_filenames;
  $realm_id2 = 0;

  /*---- Begin of the minimal functions needed ----*/
  if (isset($user_auth_realm_filenames{basename('banner.php')})) {
		$realm_id2 = $user_auth_realm_filenames{basename('banner.php')};
  }
  if ((db_fetch_assoc("select user_auth_realm.realm_id
	from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
	and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) {

	if (substr_count($_SERVER["REQUEST_URI"], "banner.php")) {
		print '<a href="' . $config['url_path'] . 'plugins/banner/banner.php"><img src="' . $config['url_path'] . 'plugins/banner/images/tab_banner-green.png" alt="banner" align="absmiddle" border="0"></a>';
	}else{
		print '<a href="' . $config['url_path'] . 'plugins/banner/banner.php"><img src="' . $config['url_path'] . 'plugins/banner/images/tab_banner.png" alt="banner" align="absmiddle" border="0"></a>';
	}

  }
  /*---- End of the minimal functions needed ----*/
  
  /* now you can put your needs */
}

function banner_api_graph_save ($save) {
	/* what happend after a click on the save button */
}

function banner_api_plugin_hook_function_body_style () {
   global $config;
   $banneractivation = 0;
   $show_console_tab = 1;
   $banneractivation = read_config_option("banneractivation");
   $show_console_tab = api_user_realm_auth('settings.php');
   if ($banneractivation) {
     print ">\n";
     print "<table>\n";
     print "<tr>";
     if (is_file("./plugins/banner/banner_top_header.php")) {
        include_once("./plugins/banner/banner_top_header.php");
     }
     print "<td>";
     bannerMessage(false,$show_console_tab);
     print "</td>";
     print "</tr>";
     print "</table>\n";
     print "\n<!-- comment to  close properly body cacti --";
   }
#print ">\n";
#print "<div>print SALUT</div>";
#print "print SALUT";
#print "<br>\n<!-- comment to  close properly body cacti --";

}

?>
